﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Serialization;

namespace Product_API_Availability_Request
{
    class Program
    {
        static void Main(string[] args)
        {
            FlightAvail();
        }

        static void FlightAvail()
        {
            // 1. Parameters (parameters you may specify on the request)

            string User = "InsertUserHere";
            string Pass = "InsertPassHere";

            string Language = "en";

            int AdultsNumber = 2;
            int ChildrenNumber = 0;
            string ChildrenAgesString = ""; // 2 digit children ages (Example: "0815", 2 children, first one of 8 years old and second one of 15 years old).

            string CountryOfResidence = "ES";

            DateTime StartDate = DateTime.Now.AddDays(30);
            DateTime EndDate = DateTime.Now.AddDays(34);

            string OriginIATA = "MAD";
            string DestinationIATA = "MCO";

            // 2. Initialization (this code initializes all of the neccesaries nodes and propestier of the FlightAvail request)

            WebServiceJP.JP_FlightAvail AvailRQ = new WebServiceJP.JP_FlightAvail();
            AvailRQ.Version = "1.1";
            AvailRQ.Language = Language;

            // 2.1. Login

            WebServiceJP.JP_Login Login = new WebServiceJP.JP_Login();
            Login.Email = User;
            Login.Password = Pass;
            AvailRQ.Login = Login;

            // 2.2. Request

            WebServiceJP.JP_FlightRequest ProductRequest = new WebServiceJP.JP_FlightRequest();
            WebServiceJP.JP_SearchSegmentsFlight SearchSegmentsFlight = new WebServiceJP.JP_SearchSegmentsFlight();
            WebServiceJP.JP_SearchSegmentFlight SearchSegmentFlight = new WebServiceJP.JP_SearchSegmentFlight();

            SearchSegmentFlight.CountryOfResidence = CountryOfResidence;

            List<WebServiceJP.JP_RouteDispo> Routes = new List<WebServiceJP.JP_RouteDispo>();

            WebServiceJP.JP_RouteDispo Route = new WebServiceJP.JP_RouteDispo();
            Route.OriginIATA = OriginIATA;
            Route.DestinationIATA = DestinationIATA;
            Route.DateSpecified = true;
            Route.Date = StartDate;
            Routes.Add(Route);

            WebServiceJP.JP_RouteDispo RouteBack = new WebServiceJP.JP_RouteDispo();
            RouteBack.OriginIATA = DestinationIATA;
            RouteBack.DestinationIATA = OriginIATA;
            RouteBack.DateSpecified = true;
            RouteBack.Date = EndDate;
            Routes.Add(RouteBack);

            SearchSegmentFlight.Routes = Routes.ToArray();


            SearchSegmentsFlight.SearchSegmentFlight = SearchSegmentFlight;
            ProductRequest.SearchSegmentsFlight = SearchSegmentsFlight;

            // 2.3. Passengers (Paxes/RelPaxesDist)

            // 2.3.1. Paxes: List of passengers and their ages
            WebServiceJP.JP_Paxes Paxes = new WebServiceJP.JP_Paxes();
            WebServiceJP.JP_Pax[] Pax;
            List<WebServiceJP.JP_Pax> PaxList = new List<WebServiceJP.JP_Pax>();

            // 2.3.2. RelPaxesDist: Distribution of passengers between rooms

            WebServiceJP.JP_RelPaxDist[] RelPaxDist;
            List<WebServiceJP.JP_RelPaxDist> RelPaxDistList = new List<WebServiceJP.JP_RelPaxDist>();
            WebServiceJP.JP_RelPaxDist RelPaxDist1 = new WebServiceJP.JP_RelPaxDist();
            WebServiceJP.JP_RelPax[] RelPax;
            List<WebServiceJP.JP_RelPax> RelPaxList = new List<WebServiceJP.JP_RelPax>();

            int passenger = 1;

            for (int adult = 1; adult <= AdultsNumber; adult += +1)
            {
                //Paxes (List of all available paxes)
                WebServiceJP.JP_Pax Pax1 = new WebServiceJP.JP_Pax();
                Pax1.IdPax = passenger;
                Pax1.AgeSpecified = true;
                Pax1.Age = 30;
                PaxList.Add(Pax1);

                //RelPaxesDist (Passengers of each room)
                WebServiceJP.JP_RelPax RelPax1 = new WebServiceJP.JP_RelPax();
                RelPax1.IdPax = passenger;
                RelPaxList.Add(RelPax1);

                passenger++;
            }

            for (int nino = 1; nino <= ChildrenNumber; nino += +1)
            {
                //Paxes (List of all available paxes)
                WebServiceJP.JP_Pax Pax1 = new WebServiceJP.JP_Pax();
                Pax1.IdPax = passenger;
                Pax1.AgeSpecified = true;

                if (ChildrenAgesString.Length < ((ChildrenNumber - 1) * 2) + 2)
                    throw new System.ArgumentException("ChildrenAgesString has not been properly specified.");

                Pax1.Age = Int32.Parse(ChildrenAgesString.Substring((ChildrenNumber - 1) * 2, 2));

                PaxList.Add(Pax1);

                //RelPaxesDist (Passengers of each room)
                WebServiceJP.JP_RelPax RelPax1 = new WebServiceJP.JP_RelPax();
                RelPax1.IdPax = passenger;
                RelPaxList.Add(RelPax1);

                passenger++;
            }

            //RelPaxesDist (Room distribution being added to the room distribution list)
            RelPax = RelPaxList.ToArray();
            RelPaxDist1.RelPaxes = RelPax;
            RelPaxDistList.Add(RelPaxDist1);
            RelPaxDist = RelPaxDistList.ToArray();
            ProductRequest.RelPaxesDist = RelPaxDist;

            //Paxes (List of all available paxes being added to the request)
            Pax = PaxList.ToArray();
            Paxes.Pax = Pax;
            AvailRQ.Paxes = Paxes;

            AvailRQ.FlightRequest = ProductRequest;

            // 2.3. AdvancedOptions (optional parameters)

            WebServiceJP.JP_FlightAvailAdvancedOptions AdvancedOptions = new WebServiceJP.JP_FlightAvailAdvancedOptions();
            AdvancedOptions.ShowBreakdownPriceSpecified = true;
            AdvancedOptions.ShowBreakdownPrice = true;

            AvailRQ.AdvancedOptions = AdvancedOptions;

            // 3. Avail Request (here we prepare and send the Avail request)

            WebServiceJP.AvailTransactionsClient serv = new WebServiceJP.AvailTransactionsClient();

            Console.WriteLine(string.Format("- AVAIL REQUEST"));
            Console.WriteLine(string.Empty);
            Console.WriteLine(string.Format("Endpoint: {0}", serv.Endpoint.Address));
            Console.WriteLine(string.Format("User: {0}", User));
            Console.WriteLine(string.Format("Pass: {0}", Pass));
            Console.WriteLine(string.Format("Routes:"));
            foreach (WebServiceJP.JP_RouteDispo route in Routes)
            {
                Console.WriteLine(string.Format("Route: {0} - {1} | {2}", route.OriginIATA, route.DestinationIATA, route.Date.ToShortDateString()));
            }

            Console.WriteLine(string.Empty);

            WebServiceJP.JP_AvailResponseRS RST = serv.FlightAvail(AvailRQ);

            // 4. Avail Response (here we process the Avail response)

            Console.WriteLine(string.Format("- AVAIL RESPONSE"));
            Console.WriteLine(string.Empty);
            if (RST != null && RST.Results != null)
            {
                int Count = 0;
                foreach (WebServiceJP.JP_Flight item in RST.Results.Items)
                {
                    Count += 1;
                }

                Console.WriteLine(string.Format("OK"));
                Console.WriteLine(string.Format("Product: {0}", Count));
            }
            else if (RST != null && RST.Errors != null)
            {
                Console.WriteLine(string.Format("KO"));
                Console.WriteLine(string.Format("Error: {0}", RST.Errors[0].Code));
            }
            else
            {
                Console.WriteLine(string.Format("KO"));
                Console.WriteLine(string.Format("Error: UNKNOWN ERROR"));
            }

            // 5. XML serialization examples (for when you require for the XML logs any of the requests/reponses)

            string rqXML = serializeXML<WebServiceJP.JP_FlightAvail>(AvailRQ);
            string rsXML = serializeXML<WebServiceJP.JP_AvailResponseRS>(RST);

            Console.ReadLine();
        }

        static string serializeXML<T>(object xmlobject)
        {
            XmlSerializer xsSubmit = new XmlSerializer(typeof(T));
            var subReq = xmlobject;

            using (var sww = new StringWriter())
            {
                using (XmlWriter writer = XmlWriter.Create(sww))
                {
                    xsSubmit.Serialize(writer, subReq);
                    return sww.ToString();
                }
            }
        }
    }
}
